/**
 * Coda "generica"
 * 
 * @author Stefano Guerrini 
 * @version Maggio 2009
 */

public interface Coda<T>{
    /**
     * Inserisce un elemento nella coda
     * 
     * Pre:         la coda non deve essere piena
     * 
     * @param obj   l'elemento da inserire nella coda
     */
    public void enqueue(T obj);
    
    /**
     * Elimina l'elemento in cima alla coda
     * 
     * Pre:         la coda non deve essere vuota
     * 
     * @retun       l'elemento eliminato dalla coda
     */
    public T dequeue();
   
    /**
     * Prende l'elemento in cima alla coda,
     * senza toglierlo dalla coda
     * 
     * Pre:         la coda non deve essere vuota
     * 
     * @retun       l'elemento in cima alla coda
     */
    public T first();
    
    /**
     * Verifica se la coda e' vuota
     * 
     * @retun       true se la coda e' vuota,
     *              false altrimenti
     */
    public boolean isEmpty();

    /**
     * Verifica se la coda e' piena e non vi si possono
     * inserire altri elementi
     * 
     * @retun       true se la coda e' piena,
     *              false altrimenti
     */
    public boolean isFull();

    /**
     * Numero di elementi presenti nella coda
     * 
     * @retun       il numero di elementi nella coda
     */
    public int numElem();

    /**
     * La dimensione della coda
     * 
     * @retun       la dimensione della coda se questa puo' contenere
     *              un numero massimo di elementi, o -1 se la coda
     *              puo' crescere senza limiti
     */
    public int size();
}
