/**
 * Pila contenente istanze di Object.
 * 
 * @author Stefano Guerrini
 * @version maggio 2009
 */

public interface PilaObj
{
    /**
     * Inserisce un elemento in cima alla pila
     * 
     * Pre:         la pila non deve essere piena
     * 
     * @param obj   l'elemento da inserire nella pila
     */
    public void push(Object obj);
    
    /**
     * Elimina l'elemento in cima alla pila
     * 
     * Pre:         la pila non deve essere vuota
     * 
     * @retun       l'elemento eliminato dalla pila
     */
    public Object pop();
   
    /**
     * Prende l'elemento in cima alla pila,
     * senza toglierlo dalla pila
     * 
     * Pre:         la pila non deve essere vuota
     * 
     * @retun       l'elemento in cima alla pila
     */
    public Object top();
    
    /**
     * Verifica se la pila e' vuota
     * 
     * @retun       true se la pila e' vuota,
     *              false altrimenti
     */
    public boolean isEmpty();

    /**
     * Verifica se la pila e' piena e non vi si possono
     * inserire altri elementi
     * 
     * @retun       true se la pila e' piena,
     *              false altrimenti
     */
    public boolean isFull();

    /**
     * Numero di elementi presenti nella pila
     * 
     * @retun       il numero di elementi nella pila
     */
    public int numElem();

    /**
     * La dimensione della pila
     * 
     * @retun       la dimensione della pila se questa puo' contenere
     *              un numero massimo di elementi, o -1 se la pila
     *              puo' crescere senza limiti
     */
    public int size();
}
