/**
 * Classe per la verifica di pile e code
 * Contiene alcune metodi generici che illustrano le
 * propriet di base dei generici
 * 
 * @author Stefano Guerrini
 * @version maggio 2009
 */
public class Test
{
    static final int N = 10;
    public static void main(String[] args) {
        System.out.println("\n== == == == ==\n");    

        // prova della pila generica
        Pila<String> pila = new ArrayPila<String>(N);
        for (int x = 0; x < N; x++) {
            pila.push(x+"");
        }
        Pila<String> newpila = new ArrayPila<String>(N);
        PilaLib.reverse2(pila, newpila);
        // Non si puo' inserire un oggetto che nonha tipo
        // String nella pila
        // Il seguente comando da' un errore a tempo di compilazione
//        pila.push(new Integer(3));
        while (!newpila.isEmpty()) {
            System.out.println(newpila.pop()+"");
        }

        System.out.println("\n-- -- -- -- --\n");
        
        PilaObj pila2 = new ArrayPilaObj(N);
        for (int x = 0; x < N; x++) {
            pila2.push(x+"");
        }
        // Posso inserire anche oggetti di tipo diverso da String nella pila
        // Il seguente comando **non** da' un errore a tempo di compilazione
//        pila2.push(new Integer(3));
        // Errore a tempo di esecuzione!!!
        // Integer non e' una sottoclasse di String
//        pila2.push((String)(pila2.pop())+"");      
        while (!pila2.isEmpty()) {
            System.out.println(pila2.pop()+"");
        }

        System.out.println("\n== == == == ==\n");    

        Coda<String> coda = new ArrayCoda<String>(N+1);
        for (int x = 0; x < N; x++) {
            coda.enqueue(x+"");
        }
        for (int x = N/2; x > 0; x--) {
            System.out.println(coda.dequeue()+"");
        }
        for (int x = N; !coda.isFull(); x++) {
            coda.enqueue(x+"");            
        }
        while (!coda.isEmpty()) {
            System.out.println(coda.dequeue()+"");
        }

        System.out.println("\n== == == == ==\n");    
    }

}
